import secrets
from flask import Flask, render_template_string, request, session, redirect, url_for
from paramiko import SSHClient, AutoAddPolicy
import re 

app = Flask(__name__)
app.secret_key = secrets.token_hex()

def tryLogin(user, password):
    try:
        client = SSHClient()
        client.set_missing_host_key_policy(AutoAddPolicy())

        client.connect('localhost', username=user, password=password)
        client.close()
        return True

    except:
        return False

def haveInstance(user, password):
    client = SSHClient()
    client.set_missing_host_key_policy(AutoAddPolicy())

    client.connect('localhost', username=user, password=password)

    stdin, stdout, stderr = client.exec_command("ls ~")

    have = False
    for line in stdout.readlines():
        if "jLabLogs.log" in line:
            have = True

        print(line)


    stdin.close()
    stdout.close()
    stderr.close()

    # Close the client itself
    client.close()

    return have

def getInstanceUrl(user, password):
    client = SSHClient()
    client.set_missing_host_key_policy(AutoAddPolicy())

    client.connect('localhost', username=user, password=password)

    stdin, stdout, stderr = client.exec_command("cat ~/jLabLogs.log")

    data = "".join(stdout.readlines())
    print(data)

    url = None

    match = re.search(r"http:\/\/127\.0\.0\.1:8888\/lab\?token=.*", data)  
    
    print(match)
    if match != None:
        ipAddr = data.split("\n")[0]
        url    = match.group(0).replace("127.0.0.1", ipAddr)

    stdin.close()
    stdout.close()
    stderr.close()

    # Close the client itself
    client.close()

    return url


def reserveNode(user, password, mem, cpus, partition, time):
    client = SSHClient()
    client.set_missing_host_key_policy(AutoAddPolicy())

    client.connect('localhost', username=user, password=password)

    stdin, stdout, stderr = client.exec_command(f"bash /usr/bin/runSaturnJupyterLab.sh {int(mem) * 1000} {cpus} {partition} {time}")
    
    print(stdout.readlines())
    print(stderr.readlines())

    
    stdin.close()
    stdout.close()
    stderr.close()

    # Close the client itself
    client.close()

@app.route('/', methods=['GET', 'POST'])
def root():
    if not session.get('user'):
        return redirect("/login")

    if request.method == 'POST':
        reserveNode(session['user'], session['password'], request.form['mem'], request.form['cpu'], request.form['partition'], request.form['time'])
        return redirect("/wait")

    if haveInstance(session['user'], session['password']):
        return redirect("/wait")

    return """
<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.3.1/dist/css/bootstrap.min.css" integrity="sha384-ggOyR0iXCbMQv3Xipma34MD+dH/1fQ784/j6cY/iJTQUOhcWr7x9JvoRxT2MZw1T" crossorigin="anonymous">

<div class="row mt-5">
<div class="col-sm-4"></div>
  <div class="col-sm-4">
<form class="form-horizontal" action="" method="post">
  <center>
    <h2>Reservation Form</h2>
    <p>for jupyter lab</p>
  </center>

  <div class="form-group">
    <label class="control-label">Number of CPUs</label>
    <input name="cpu" value="4" class="form-control" type="number" min="1" required>   
  </div>
  
  <div class="form-group">
    <label class="control-label">Memory [GB]</label>
    <input name="mem" value="2" class="form-control" type="number" min="1" required>   
  </div>
  
  <!--div class="form-group">
    <label class="control-label">GPU</label>
    <select name="department" class="form-control selectpicker">
      <option value="">none</option>
      <option value="tesla">1x Tesla P4</option>
    </select> 
  </div-->

  <div class="form-group">
    <label class="control-label">Partition</label>
    <select name="partition" class="form-control selectpicker" required>
      <option value="debug">Debug</option>
      <option value="exp">Exp</option>
      <option value="long">Long</option>
    </select> 
  </div>
  
  <div class="form-group">
    <label class="control-label">Time [Min]</label>
    <input  name="time" value="60" class="form-control" type="number" min="10" required>   
  </div>

<center>
  <button type="submit" class="btn btn-warning">Reserve</button>
</center>
</form>
</div>
<div class="col-sm-4"></div>
</div>
"""


@app.route('/login', methods=['GET', 'POST'])
def login():
    errorState = ""
    if request.method == 'POST':
        if tryLogin(request.form['user'], request.form['password']):
            session['user']     = request.form['user']
            session['password'] = request.form['password']
            return redirect("/")
        errorState = "Error: fail to login"

    return """
<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.3.1/dist/css/bootstrap.min.css" integrity="sha384-ggOyR0iXCbMQv3Xipma34MD+dH/1fQ784/j6cY/iJTQUOhcWr7x9JvoRxT2MZw1T" crossorigin="anonymous">

<div class="row mt-5">
<div class="col-sm-4"></div>
<div class="col-sm-4">
<form method="POST" enctype="multipart/form-data">
  <div data-mdb-input-init class="form-outline mb-4">
    <input type="text" name="user" class="form-control" required/>
    <label class="form-label">User</label>
  </div>

  <div data-mdb-input-init class="form-outline mb-4">
    <input type="password" name="password" class="form-control" required/>
    <label class="form-label">Password</label>
  </div>

  <p>""" + errorState + """</p>

  <button  type="submit" data-mdb-button-init data-mdb-ripple-init class="btn btn-primary btn-block mb-4">Sign in</button>
</form>
<div class="row">
</div>
<div class="col-sm-4"></div>
        """


@app.route('/wait')
def instanceWait():
    user     = session['user']
    password = session['password']

    if not haveInstance(user, password):
        return redirect("/")

    url = getInstanceUrl(user, password)
    if url is not None:
        return redirect(url)

    return """
<style>
@import url('https://fonts.googleapis.com/css?family=Inconsolata');

* {
  margin: 0;
  padding: 0;
  box-sizing: border-box;
}

html, body {
  width: 100%;
  height: 100%;
}

body {
  font-family: 'Inconsolata', monospace;
  overflow: hidden;
}

h1 {
  position: absolute;
  height: 40px;
  margin: auto;
  top: 200px;
  left: 0;
  right: 0;
  bottom: 0;
  text-transform: uppercase;
  text-align: center;
  letter-spacing: 0.1em;
  font-size: 14px;
  font-weight: lighter;
  color: black;

  span {
    display: none;
  }

  &::after {
    animation: txt 5s infinite;
    content: "";
  }

}

@keyframes txt {
  0% {
    content: "Waiting for resources.";
  }
  50% {
    content: "Waiting for resources..";
  }
  100% {
    content: "Waiting for resources...";
  }
}

</style>

<div class="arc">
</div>
<h1><span>Waiting for resources</span></h1>

<script>
window.setTimeout( function() {
  window.location.reload();
}, 30000);
</script>
"""

if __name__ == '__main__':
    app.run(host="0.0.0.0")
